/*
* Name: Copy Cell Text
* Developer: Andrew Connor + Zack Arnett
* Date: 12/19/2018
*/
define(function () {
  var install = function (holderElement, context) {
    var widgetElement = holderElement;
    var cell = context.getCell();
	
	var icon;
	try {
		icon = context.getParameter("Icon");
	}
	catch (err) {
		icon = "fa-clipboard";
	}
	var tooltipText;
	try {
		tooltipText = context.getParameter("TooltipText");
	}
	catch (err) {
		tooltipText = "Copied!";
	}
	
  widgetElement.children[0].classList.add(icon);
  
    widgetElement.setAttribute('title', tooltipText);
	
    widgetElement.setAttribute('data-clipboard-text', cell.value);

    $(widgetElement).tooltip({
      trigger: 'click'
    });

    var Clipboard = context.loadedDependencies[0];
    var clipboard = new Clipboard(widgetElement);
    clipboard.on('success', function(e) {
      setTimeout(function(){
          $(widgetElement).tooltip('hide');
      }, 1000);
    });
  };

  var uninstall = function (holderElement, context) {
  };

  return {
    callbacks: {
      events: {
        // adding and removing
        install: install,
        uninstall: uninstall
      }
    }
  };
});